<chapter xmlns="http://docbook.org/ns/docbook" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:xi="http://www.w3.org/2001/XInclude" version="5.0" xml:lang="hu">
    <info>
        <title>Helló, Arroway!</title>
        <keywordset>
            <keyword/>
        </keywordset>
    </info>

    <section>
        <title>OO szemlélet</title>
            <para>
				A módosított polártranszformációs normális generátor beprogramozása Java nyelven. Mutassunk rá,
				hogy a mi természetes saját megoldásunk (az algoritmus egyszerre két normálist állít elő, kell egy
				példánytag, amely a nem visszaadottat tárolja és egy logikai tag, hogy van-e tárolt vagy futtatni kell
				az algot.) és az OpenJDK, Oracle JDK-ban a Sun által adott OO szervezés ua.!
				Ugyanezt írjuk meg C++ nyelven is! (lásd még UDPROG repó: source/labor/polargen)
			</para>
			<para>
				A módosított polártranszformációs normális generátor egy olyan algoritmus, amivel mi kitünő termeléshatékonysággal vagyunk képesek pseudorandom számokat generálni.
				Az optimalizáltságát az a tulajdonsága adja, hogy egyszeri lefutása során nem egy, hanem egyenes két véletlenszámot kapunk, így ha eltároljuk a kettő közül az egyiket
				következő hívásnál elég őt visszaadni nem szükséges újra megdolgoztatni a processzorunkat.
			</para>
			<para>
				A programban például a g egy PolarGenerator osztályba tartozó objektum. Ez két változóval indul alapból és a nincsTarolt kezdeti értéke is adott. Továbbá a programban meghívjuk rá a
				kovetkezo függvényt, melynek segítségével generálódnak a véletlenszerűen számok. Mint látjuk a függvény jól működik, azaz tényleg létezik a két változója a g-nek, amit a függvény
				felhasznál. Tehát a g-re probléma nélkül meg tudtuk hívni ezt a függvényt és megfelelően működött.
			</para>
			<programlisting language="java"><![CDATA[
public class PolarGenerator
{
	boolean nincsTarolt=true;
	double tarolt;

	public PolarGenerator()
	{
		nincsTarolt=true;
	}

	public double kovetkezo()
	{
		if(nincsTarolt)
		{
			double u1,u2,v1,v2,w;
	
			do {
			u1=Math.random();
			u2=Math.random();
			v1=2*u1-1;
			v2=2*u2-1;
			w=v1*v1+v2*v2;
			}
			while (w>1);
	
			double r= Math.sqrt( (-2*Math.log(w)) / w );
			tarolt = r * v2;
			nincsTarolt=!nincsTarolt;
			return r*v1;
		} 
		else
		{
			nincsTarolt = !nincsTarolt;
			return  tarolt;
		}
	}

	public static void main (String[] args)
	{
		PolarGenerator g = new PolarGenerator ();
		for (int i=0; i<10; i++)
		{
			System.out.println( g.kovetkezo() );
		}
	}
}
   ]]></programlisting>
		<para>
			Ugyanez C++-ban.
		</para>
		<programlisting language="C++"><![CDATA[
		#include <iostream>
#include <cstdlib>	
#include <cmath>	
#include <ctime>	

class PolarGenerator 
{

	public:

		PolarGenerator(); 
        double kovetkezo(); 
        ~PolarGenerator(){} 

	private:
		bool nincsTarolt;
		double tarolt;
};


PolarGenerator::PolarGenerator()
{
	nincsTarolt = true;
	std::srand (std::time(NULL));
};


double PolarGenerator::kovetkezo() 
{ 
	if (nincsTarolt)
{
		double u1, u2, v1, v2, w;

		do
        {
			u1 = std::rand () / (RAND_MAX + 1.0); 
			u2 = std::rand () / (RAND_MAX + 1.0);
			v1 = 2 * u1 - 1;
			v2 = 2 * u2 - 1;
			w = v1 * v1 + v2 * v2;
        }
		while (w > 1);

		double r = std::sqrt ((-2 * std::log (w)) / w);

		tarolt = r * v2; 
		nincsTarolt = !nincsTarolt;

		return r * v1; 
	}
	
	else
	{
		nincsTarolt = !nincsTarolt;
		return tarolt;
	}
};    

int main() 
{

	PolarGenerator g;

	for (int i = 0; i < 10; ++i) 
        std::cout << g.kovetkezo() << std::endl;

}
	]]></programlisting>
		

    </section>


	<section>
        <title>Homokózó</title>
			<para>
				Írjuk át az első védési programot (LZW binfa) C++ nyelvről Java nyelvre, ugyanúgy működjön!
				Mutassunk rá, hogy gyakorlatilag a pointereket és referenciákat kell kiirtani és minden máris működik
				(erre utal a feladat neve, hogy Java-ban minden referencia, nincs választás, hogy mondjuk egy
				attribútum pointer, referencia vagy tagként tartalmazott legyen).
			</para>
			<para>
				Miután már áttettük Java nyelvre, tegyük be egy Java Servletbe és a böngészőből GET-es kéréssel
				(például a böngésző címsorából) kapja meg azt a mintát, amelynek kiszámolja az LZW binfáját!
			</para>
			<para>
				<programlisting language="java"><![CDATA[
		import java.io.PrintWriter;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.FileNotFoundException;
class LZWBinaryTree
{
    public LZWBinaryTree ()
    {
    	root = new Node('/');
    	currentNode = root;
    }
  
    public void insert (char b)
    {
        if (b == '0')
        {
            if (currentNode.getLeftChild () == null)	
            {
                Node n = new Node ('0');
                currentNode.newLeftChild (n);
                currentNode = root;
            }
            else			
            {
                currentNode = currentNode.getLeftChild ();
            }
        }
        
        else
        {
            if (currentNode.getRightChild () == null)
            {
                Node n = new Node ('1');
                currentNode.newRightChild (n);
                currentNode = root;
            }
            else
            {
                currentNode = currentNode.getRightChild ();
            }
        }
    }
    
    public int getDepth ()
    {
    	 	depth = maxDepth = 0;
    	    recDepth (root);
    	    return maxDepth - 1;
    }
    public double getMean ()
    {
    	depth = sumOfMean = numberOfNodes = 0;
        recMean (root);
        mean = ((double) sumOfMean) / numberOfNodes;
        return mean;
    }
    public double getVariance ()
    {
    	mean = getMean ();
        sumOfVar = 0.0;
        depth = numberOfNodes = 0;

        recVar (root);

        if (numberOfNodes - 1 > 0)
            variance = Math.sqrt (sumOfVar / (numberOfNodes - 1));
        else
            variance = Math.sqrt (sumOfVar);

        return variance;
    }

    public void recDepth (Node  n)
    {
        if (n != null)
        {
            ++depth;
            if (depth > maxDepth)
                maxDepth = depth;
            recDepth (n.getRightChild ());
            
            recDepth (n.getLeftChild ());
            --depth;
        }
    }


public void recMean (Node  n)
{
    if (n != null)
    {
        ++depth;
        recMean (n.getRightChild ());
        recMean (n.getLeftChild ());
        --depth;
        if (n.getRightChild () == null && n.getLeftChild () == null)
        {
            ++numberOfNodes;
            sumOfMean += depth;
        }
    }
}

public void recVar (Node  n)
{
    if (n != null)
    {
        ++depth;
        recVar (n.getRightChild ());
        recVar (n.getLeftChild ());
        --depth;
        if (n.getRightChild () == null && n.getLeftChild () == null)
        {
            ++numberOfNodes;
            sumOfVar += ((depth - mean) * (depth - mean));
        }
    }
}
    public void printTree (PrintWriter os)
    {
        depth = 0;
        printTree (root, os);
    }

    class Node
    {
      
        Node (char b)
        {
        	if(b == '0' || b == '1')
        		value = b;
        	else
        	value = '/';
        };
 
        Node getLeftChild () 
        {
            return leftChild;
        }
        
        Node getRightChild () 
        {
            return rightChild;
        }
        
        void newLeftChild (Node gy)
        {
            leftChild = gy;
        }
        
        void newRightChild (Node gy)
        {
            rightChild = gy;
        }
      
        char getValue () 
        {
            return value;
        }
       

        
        private char value;
       
        private Node leftChild;
        private Node rightChild;
    };

   
    Node currentNode;
    
    private int depth, sumOfMean, numberOfNodes;
    private double sumOfVar;
    

    
    public void printTree (Node  n, PrintWriter os)
    {
        
        if (n != null)
        {
            ++depth;
            printTree (n.getLeftChild (), os);
            
            
            for (int i = 0; i < depth; ++i)
                os.print("---");
            os.print(n.getValue () + "(" + depth + ")\n");
            printTree (n.getRightChild (), os);
            --depth;
        }
    }
   
	protected Node root;
    protected int maxDepth;
    protected double mean, variance;


    public static void usage ()
    {
        System.out.println("Usage: lzwtree in_file -o out_file");
    }

    public static void  main (String[] args) throws FileNotFoundException, IOException
    {
        
        if (args.length  < 3)
        {
            usage ();
            return;
        }

        String inFile = args[0];

        
        if(!args[1].equals("-o"))
        {
        	 System.out.println(args[1]);
        	 usage ();
             return;
        }

        
        java.io.FileInputStream input = new java.io.FileInputStream(new java.io.File(inFile));

        
        if (input == null)
        {
            System.out.println("Nem létezik");
            usage ();
            return;
        }
        PrintWriter output = new PrintWriter(args[2]);

        byte[] b = new byte[1];		
        LZWBinaryTree bincurrentNode = new LZWBinaryTree();		
        while (input.read(b) != -1)
        {
            if (b[0] == 0x0a)
            {
            break;
            }
        }
        
        boolean inComment = false;
        while (input.read (b) != -1) 
        {
            if (b[0] == 0x3e) 
            {			
                inComment = true;
                continue;
            }
            if (b[0] == 0x0a) 
            {			
                inComment = false;
                continue;
            }
            if (inComment)
            {
                continue;
            }
            if (b[0] == 0x4e)
            {
                continue;
            }
            for (int i = 0; i < 8; ++i)
            {
                if ((b[0] & 0x80) != 0)
                {
                    bincurrentNode.insert('1');
                } 
                else
                {
                    bincurrentNode.insert('0');
                }
                b[0] <<= 1;
            }
        }
        
        bincurrentNode.printTree(output);		

        output.print("depth " + bincurrentNode.getDepth () + "\n");
        output.print("mean " + bincurrentNode.getMean () + "\n");
        output.print("var " + bincurrentNode.getVariance () + "\n");

        output.close ();
        input.close ();
    }
};
   ]]></programlisting>
		</para>
		<para>
			A legszembetűnőbb a *-gal jelölt mutatók eltűnése, Javaban nincsenek mutatók, minden objektum referencia, azaz amikor mi
			példányosítunk egy osztályt mi csak egy referenciát kapunk az objektumra amin keresztül elérhetjük, ez nyílvánalóan
			a Garbage Collector miatt működik így, ugyanis az felelős a heapen lefoglalt hely utáni felszabadításért, és ezt úgy teszi,
			hogy nyílvántartja hány referencia él még az egyes objektumokra, ha ezek száma nullával lesz egyenlő akkor felszabadítja a terület.
		</para>
		<para>
			Referencia miatt referencia által történik az argumentumok átadása az egyes metódusokba, nem másolatokkal fogunk dolgozni.
		</para>
    
    </section>

    <section>
        <title>„Gagyi”</title>
        	<para>
				Az ismert formális „while (x &lt;= t &amp;&amp; x &gt;= t &amp;&amp; t != x);” tesztkérdéstípusra adj a szokásosnál
				(miszerint x, t az egyik esetben az objektum által hordozott érték, a másikban meg az objektum
				referenciája) „mélyebb” választ, írj Java példaprogramot mely egyszer végtelen ciklus, más x, t
				értékekkel meg nem! A példát építsd a JDK Integer.java forrására 3, hogy a 128-nál inkluzív objektum
				példányokat poolozza!
			</para>
			<para>
				A fent említett tesztkérdés "szokásosan" Java tesztkérdésként szokott előjönni
				az univerzumban, hiszen egy nagyon alap és köztudott működésére kérdez rá. 
				<emphasis>Mikor egyenlő két objektum?</emphasis>
			</para>
			<para>
				Kétfajta egyenlőséget különböztetünk meg, az egyik a "érték szerinti" egyenlőség,
				a másik az "identitáson alapuló" egyenlőség.
			</para>
			<para>
				Az <emphasis>"érték-szerinti"</emphasis> egyenlőség pontosan azt jelenti
				amit elsőre is gondolnánk, két érték egyenlő, valamik által horodozott
				értékek megegyeznek.
			</para>
			<programlisting language='Java'>
            <![CDATA[
import java.lang.Number;

class Gagyi1138
{
		public static void main(String[] args)
	{
		Integer t = 1138;
		Integer x = 1138;
		
		while(x <= t && x>=t && t != x)
			System.out.println("jajj");
	}
}
]]>
        </programlisting>
        <para>
            A fenti kód egyértelműen végtelen ciklust eredményez: Az x &lt;= t és x &gt;= t kifejezések igazra fognak kiértékelődni, hiszen 1138==1138. Az t != x szintén igaz lesz, mivel az osztályból két
			példányt példányosítottunk, amik nyílván nem lehetnek egyenlőek.
		</para>
        <para>
            Az adott osztály gyorsítótárazási tulajdonságát kihasználva azonban képesek vagyunk a fenti kódban, csupán az <filename>Integer</filename>ek értékeinek átírásával, megszüntetni a
			végtelen ciklust.
        </para>
        <programlisting language='Java'>
            <![CDATA[
import java.lang.Number;

class Gagyi
{
	public static void main(String[] args)
	{
		Integer t = 127;
		Integer x = 127;
		
		while(x <= t && x>=t && t != x)
			System.out.println("jajj");
	}
}        
]]>
        </programlisting>
        <para>
            Az <filename>Integer</filename> osztály a [-128;127] értéktartományt gyorsítótárazza, így minden olyan esetben amikor ebből a tartományból választunk literált,
            vagy a <function>valueOf</function> metódust meghívva, mi mindig egy már létező objektumra kapunk egy-egy referenciát, tehát megbukik az x != t feltétel.
        </para>

    </section>

    <section>
        <title>Yoda</title>
        	<para>
				Írjunk olyan Java programot, ami java.lang.NullPointerEx-el leáll, ha nem követjük a <link xlink:href="https://en.wikipedia.org/wiki/Yoda_conditions">Yoda conditions</link>-t!
			</para>
			<para>
            A Yoda conditions a nevét a Star Wars filmekből ismert Yoda karaktertől kapta, aki beszéde során felborítja a nyelv szintaxisát. Ez programozáskor akkor fordul elő, ha a
			feltételekben felcseréljük a vizsgált dolgot azzal a dologgal, amihez hasonlítjuk, például e helyett:
        </para>
        <para>
            <code><![CDATA[if(vehicle == "Car")]]></code>, ezt írjuk:
        </para>
        <para>
             <code><![CDATA[if("Car" == vehicle)]]></code>
        </para>
        <para>
            Bár első ránézésre érdektelennek tűnhet, egyáltalán nem mindegy a sorrend, mert kivételt, például NullPointerException-t, dobhat programunk futás alatt. Javaban ez akkor eshet meg, ha
			például null-on hívunk meg metódusokat, illetve a következő esetekben:
        </para>
        <itemizedlist mark='opencircle'>
            <listitem>
                <para>Egy null objektum adattagjaihoz akarunk hozzáférni.</para>
            </listitem>
            <listitem>
                <para>A null objektumot tömbként kezelve, vesszük hosszát.</para>
            </listitem>
            <listitem>
                <para>A null, mint tömb, elemihez akarunk hozzáférni.</para>
            </listitem>
            <listitem>
                <para>null-t dobunk throw utasítással.</para>
            </listitem>
        </itemizedlist>
        <para>
            Például a lenti kód akkor nem dobna kivételt, ha az első if-es szerkezet ki lenne kommentelve, hiszen nem hívnánk meg null objektum metódusát.
        </para>
        <programlisting language='Java'>
            <![CDATA[
class Yoda {
	public static void main (String[] args)
	{
		String vehicle = null;
		if(vehicle.equals("Car"))
		{
			System.out.println("Rossz.");
		}	
		if("Car".equals(vehicle))
		{
			System.out.println("Jo.");
		}
	}
}
]]>
        </programlisting>

    </section>
        
</chapter>                
